'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-bdeef4f4.js');
const defaultIconPack = require('./default-icon-pack-0ea0e986.js');
const index$1 = require('./index-dbc5b08f.js');
const fullScreen = require('./full-screen-65a0d897.js');
require('./default-language-4c779255.js');

const dyteFullscreenToggleCss = ":host{display:block;font-family:var(--dyte-font-family, sans-serif)}";

const DyteFullscreenToggle = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /** Variant */
    this.variant = 'button';
    /** Icon pack */
    this.iconPack = defaultIconPack.defaultIconPack;
    /** Language */
    this.t = index$1.useLanguage();
    this.fullScreenActive = false;
    this.isFullScreenSupported = true;
    this.toggleFullScreen = () => {
      const fullScreenElement = document.querySelector('dyte-meeting');
      if (!fullScreenElement)
        return;
      if (!this.fullScreenActive) {
        fullScreen.requestFullScreen(fullScreenElement);
        this.fullScreenActive = true;
      }
      else {
        fullScreen.exitFullSreen();
        this.fullScreenActive = false;
      }
    };
  }
  connectedCallback() {
    this.isFullScreenSupported = fullScreen.isFullScreenSupported();
    this.handleFullScreenChange = () => {
      this.fullScreenActive = fullScreen.isFullScreenEnabled();
    };
    window.addEventListener('webkitfullscreenchange', this.handleFullScreenChange);
    window.addEventListener('fullscreenchange', this.handleFullScreenChange);
  }
  disconnectedCallback() {
    window.removeEventListener('webkitfullscreenchange', this.handleFullScreenChange);
    window.removeEventListener('fullscreenchange', this.handleFullScreenChange);
  }
  render() {
    if (!this.isFullScreenSupported) {
      return null;
    }
    return (index.h(index.Host, { title: this.t('Fullscreen') }, index.h("dyte-controlbar-button", { size: this.size, iconPack: this.iconPack, onClick: this.toggleFullScreen, icon: this.fullScreenActive
        ? this.iconPack.full_screen_minimize
        : this.iconPack.full_screen_maximize, label: this.t('Fullscreen'), variant: this.variant })));
  }
};
DyteFullscreenToggle.style = dyteFullscreenToggleCss;

exports.dyte_fullscreen_toggle = DyteFullscreenToggle;
