'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-bdeef4f4.js');
const defaultIconPack = require('./default-icon-pack-0ea0e986.js');
const index$1 = require('./index-dbc5b08f.js');
const store = require('./store-d570e98c.js');
require('./default-language-4c779255.js');

const dytePollsToggleCss = ":host{position:relative;display:block;font-family:var(--dyte-font-family, sans-serif)}.unread-count{position:absolute;right:var(--dyte-space-3, 12px);box-sizing:border-box;padding:var(--dyte-space-0\\.5, 2px);-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;--tw-bg-opacity:1;background-color:rgba(var(--dyte-colors-brand-500, 33 96 253) / var(--tw-bg-opacity));font-size:12px;display:flex;height:var(--dyte-space-5, 20px);min-width:var(--dyte-space-5, 20px);align-items:center;justify-content:center;border-radius:9999px;z-index:1}:host([variant='horizontal']){display:flex;flex-direction:row-reverse;align-items:center}:host([variant='horizontal']) .unread-count{right:var(--dyte-space-4, 16px);top:auto}";

const DytePollsToggle = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.stateUpdate = index.createEvent(this, "dyteStateUpdate", 7);
    /** Variant */
    this.variant = 'button';
    /** Icon pack */
    this.iconPack = defaultIconPack.defaultIconPack;
    /** Language */
    this.t = index$1.useLanguage();
    this.pollsActive = false;
    this.unreadPollsCount = 0;
    this.onPollsUpdate = () => {
      this.unreadPollsCount += 1;
    };
  }
  connectedCallback() {
    this.meetingChanged(this.meeting);
    this.statesChanged(this.states);
    store.onChange('sidebar', () => this.statesChanged());
  }
  meetingChanged(meeting) {
    if (meeting != null) {
      this.unreadPollsCount = meeting.polls.items.length;
      this.meeting.polls.on('pollsUpdate', this.onPollsUpdate);
    }
  }
  statesChanged(s) {
    const states = s || store.state;
    if (states != null) {
      this.pollsActive = states.activeSidebar === true && states.sidebar === 'polls';
    }
  }
  togglePollsTab() {
    const states = this.states || store.state;
    this.unreadPollsCount = 0;
    this.pollsActive = !((states === null || states === void 0 ? void 0 : states.activeSidebar) && (states === null || states === void 0 ? void 0 : states.sidebar) === 'polls');
    this.stateUpdate.emit({
      activeSidebar: this.pollsActive,
      sidebar: this.pollsActive ? 'polls' : 'none',
    });
    store.state.activeSidebar = this.pollsActive;
    store.state.sidebar = this.pollsActive ? 'polls' : 'none';
  }
  render() {
    var _a;
    const text = this.t('polls');
    if ((_a = this.meeting) === null || _a === void 0 ? void 0 : _a.self.suggestedTheme
    // !this.meeting.self.suggestedTheme.controlBar.elements.polls
    )
      return;
    return (index.h(index.Host, { title: text }, this.unreadPollsCount !== 0 && !this.pollsActive && (index.h("div", { class: "unread-count", part: "unread-count" }, index.h("span", null, this.unreadPollsCount > 99 ? '99+' : this.unreadPollsCount))), index.h("dyte-controlbar-button", { part: "controlbar-button", size: this.size, iconPack: this.iconPack, class: { active: this.pollsActive }, onClick: () => this.togglePollsTab(), icon: this.iconPack.poll, label: text, variant: this.variant })));
  }
  static get watchers() { return {
    "meeting": ["meetingChanged"],
    "states": ["statesChanged"]
  }; }
};
DytePollsToggle.style = dytePollsToggleCss;

exports.dyte_polls_toggle = DytePollsToggle;
