import { Component, Host, h, Prop } from '@stencil/core';
const parseIcon = (icon) => {
  try {
    return JSON.parse(icon);
  }
  catch (e) {
    return icon;
  }
};
/**
 * An icon component which accepts an svg string and renders it.
 */
export class DyteIcon {
  render() {
    return (h(Host, null,
      h("div", { class: "icon-wrapper", innerHTML: parseIcon(this.icon), part: "wrapper" })));
  }
  static get is() { return "dyte-icon"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["dyte-icon.css"]
  }; }
  static get styleUrls() { return {
    "$": ["dyte-icon.css"]
  }; }
  static get properties() { return {
    "icon": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Icon"
      },
      "attribute": "icon",
      "reflect": false
    }
  }; }
}
