import { r as registerInstance, h, H as Host } from './index-74ddb327.js';
import { u as useLanguage } from './index-a214afbc.js';
import { d as defaultIconPack } from './default-icon-pack-eabba256.js';
import { o as onChange, s as state } from './store-79928517.js';
import { d as defaultConfig } from './default-ui-config-c5d610a7.js';
import './default-language-04851639.js';

const dyteEndedScreenCss = ":host{height:100%;width:100%;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;font-family:var(--dyte-font-family, sans-serif);display:flex;flex-direction:column;align-items:center;justify-content:center}.ctr{display:flex;flex-direction:column;align-items:center}dyte-logo{margin-bottom:var(--dyte-space-8, 32px);height:var(--dyte-space-12, 48px)}.rejoin-button{margin-top:var(--dyte-space-4, 16px);margin-bottom:var(--dyte-space-4, 16px);padding-top:var(--dyte-space-6, 24px);padding-bottom:var(--dyte-space-6, 24px);padding-left:var(--dyte-space-16, 64px);padding-right:var(--dyte-space-16, 64px)}.rejoin-icon{margin-right:var(--dyte-space-2, 8px)}p{font-size:16px;border-radius:var(--dyte-border-radius-lg, 12px);--tw-bg-opacity:1;background-color:rgba(var(--dyte-colors-background-800, 30 30 30) / var(--tw-bg-opacity));padding-left:var(--dyte-space-8, 32px);padding-right:var(--dyte-space-8, 32px);padding-top:var(--dyte-space-4, 16px);padding-bottom:var(--dyte-space-4, 16px);color:rgb(var(--dyte-colors-text-1000, 255 255 255))}span{margin-top:var(--dyte-space-4, 16px);margin-bottom:var(--dyte-space-4, 16px);font-size:14px}";

const DyteEndedScreen = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /** Config object */
    this.config = defaultConfig;
    /** Icon */
    this.icon = defaultIconPack;
    /** Language */
    this.t = useLanguage();
    this.message = '';
  }
  connectedCallback() {
    this.statesChanged(this.states);
    onChange('roomLeftState', () => this.statesChanged());
  }
  statesChanged(s) {
    const states = s || state;
    if (states != null) {
      switch (states === null || states === void 0 ? void 0 : states.roomLeftState) {
        case 'left':
          this.message = 'You left the meeting';
          break;
        case 'kicked':
          this.message = 'You were removed from the meeting';
          break;
        case 'disconnected':
          this.message = 'The call ended because the connection was lost.';
          break;
        default:
          this.message = 'The meeting ended';
      }
    }
  }
  render() {
    const states = this.states || state;
    return (h(Host, null, h("div", { class: "ctr", part: "container" }, h("dyte-logo", { config: this.config, part: "logo" }), h("p", { part: "message" }, this.t(this.message)), (states === null || states === void 0 ? void 0 : states.roomLeftState) === 'disconnected' && (h("span", { part: "description" }, this.t('Please check your internet connection and try again.'))))));
  }
  static get watchers() { return {
    "states": ["statesChanged"]
  }; }
};
DyteEndedScreen.style = dyteEndedScreenCss;

export { DyteEndedScreen as dyte_ended_screen };
