import { IconPack } from '../../lib/icons';
import { States } from '../../types/props';
import { Meeting } from '../../types/dyte-client';
export declare type GridPaginationVariants = 'solid' | 'rounded' | 'grid';
/**
 * A component which allows you to change current page and view mode
 * of active participants list. This is reflected in the `dyte-grid` component.
 */
export declare class DyteGridPagination {
  /** Meeting object */
  meeting: Meeting;
  /** States */
  states: States;
  /** Variant */
  variant: GridPaginationVariants;
  /** Icon Pack */
  iconPack: IconPack;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  page: number;
  pageCount: number;
  connectedCallback(): void;
  disconnectedCallback(): void;
  meetingChanged(meeting: Meeting): void;
  private onPageChanged;
  private onParticipantUpdate;
  private prevPage;
  private nextPage;
  render(): any;
}
