import { IconPack } from '../../lib/icons';
import { Meeting } from '../../types/dyte-client';
import { Size } from '../../types/props';
/**
 * A component which indicates the recording status of a meeting.
 *
 * It will not render anything if no recording is taking place.
 */
export declare class DyteRecordingIndicator {
  private updateRecordingStatus;
  /** Meeting object */
  meeting: Meeting;
  /** Size */
  size: Size;
  /** Language */
  t: import("../../lib/lang").DyteI18n;
  /** Icon pack */
  iconPack: IconPack;
  isRecording: boolean;
  connectedCallback(): void;
  disconnectedCallback(): void;
  meetingChanged(meeting: Meeting): void;
  private setIsRecording;
  render(): any;
}
