'use strict';

const index = require('./index-bdeef4f4.js');

/*
 Stencil Client Patch Browser v2.17.0 | MIT Licensed | https://stenciljs.com
 */
const patchBrowser = () => {
    const importMeta = (typeof document === 'undefined' ? new (require('u' + 'rl').URL)('file:' + __filename).href : (document.currentScript && document.currentScript.src || new URL('dyte-ui-kit.cjs.js', document.baseURI).href));
    const opts = {};
    if (importMeta !== '') {
        opts.resourcesUrl = new URL('.', importMeta).href;
    }
    return index.promiseResolve(opts);
};

patchBrowser().then(options => {
  return index.bootstrapLazy(JSON.parse("[[\"dyte-icon.cjs\",[[1,\"dyte-icon\",{\"icon\":[1]}]]],[\"dyte-chat.cjs\",[[1,\"dyte-chat\",{\"meeting\":[16],\"config\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"chat\":[32],\"shiftDown\":[32],\"now\":[32],\"autoScrollEnabled\":[32],\"dropzoneActivated\":[32],\"canSend\":[32],\"canSendTextMessage\":[32],\"canSendFiles\":[32],\"emojiPickerEnabled\":[32]}]]],[\"dyte-participants.cjs\",[[1,\"dyte-participants\",{\"meeting\":[16],\"config\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"search\":[32],\"participants\":[32]}]]],[\"dyte-settings.cjs\",[[1,\"dyte-settings\",{\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"activeTab\":[32],\"isMobileMainVisible\":[32],\"networkStatus\":[32],\"canProduceAudio\":[32],\"canProduceVideo\":[32]}]]],[\"dyte-screenshare-view.cjs\",[[1,\"dyte-screenshare-view\",{\"hideFullScreenButton\":[4,\"hide-full-screen-button\"],\"nameTagPosition\":[513,\"name-tag-position\"],\"participant\":[16],\"meeting\":[16],\"variant\":[513],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"videoExpanded\":[32],\"screenShareEnabled\":[32],\"isFullScreen\":[32],\"remoteControlInfo\":[32]}]]],[\"dyte-polls.cjs\",[[1,\"dyte-polls\",{\"meeting\":[16],\"config\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"create\":[32],\"polls\":[32]}]]],[\"dyte-camera-toggle.cjs\",[[1,\"dyte-camera-toggle\",{\"variant\":[513],\"meeting\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"videoEnabled\":[32],\"canProduceVideo\":[32],\"cameraPermission\":[32]}]]],[\"dyte-mic-toggle.cjs\",[[1,\"dyte-mic-toggle\",{\"variant\":[513],\"meeting\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"audioEnabled\":[32],\"canProduceAudio\":[32],\"micPermission\":[32]}]]],[\"dyte-remote-access-manager.cjs\",[[1,\"dyte-remote-access-manager\",{\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"acceptedRequestId\":[32]}]]],[\"dyte-screen-share-toggle.cjs\",[[1,\"dyte-screen-share-toggle\",{\"variant\":[513],\"meeting\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"maxScreenShareCount\":[32],\"screenShareCount\":[32],\"screenShareEnabled\":[32],\"canScreenShare\":[32],\"shareScreenPermission\":[32]}]]],[\"dyte-chat-toggle.cjs\",[[1,\"dyte-chat-toggle\",{\"variant\":[513],\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"unreadMessageCount\":[32],\"chatActive\":[32]}]]],[\"dyte-dialog-manager.cjs\",[[1,\"dyte-dialog-manager\",{\"meeting\":[16],\"config\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16]}]]],[\"dyte-fullscreen-toggle.cjs\",[[1,\"dyte-fullscreen-toggle\",{\"variant\":[513],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"fullScreenActive\":[32],\"isFullScreenSupported\":[32]}]]],[\"dyte-grid-pagination.cjs\",[[1,\"dyte-grid-pagination\",{\"meeting\":[16],\"states\":[16],\"variant\":[513],\"iconPack\":[16],\"t\":[16],\"page\":[32],\"pageCount\":[32]}]]],[\"dyte-idle-screen.cjs\",[[1,\"dyte-idle-screen\",{\"config\":[16]}]]],[\"dyte-leave-button.cjs\",[[1,\"dyte-leave-button\",{\"variant\":[513],\"size\":[513],\"iconPack\":[16],\"t\":[16]}]]],[\"dyte-more-toggle.cjs\",[[1,\"dyte-more-toggle\",{\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"isOpen\":[32]}]]],[\"dyte-notifications.cjs\",[[1,\"dyte-notifications\",{\"meeting\":[16],\"states\":[16],\"config\":[16],\"t\":[16],\"size\":[513],\"iconPack\":[16],\"notifications\":[32]}]]],[\"dyte-participants-audio.cjs\",[[1,\"dyte-participants-audio\",{\"meeting\":[16],\"t\":[16],\"showPlayDialog\":[32]}]]],[\"dyte-participants-toggle.cjs\",[[1,\"dyte-participants-toggle\",{\"variant\":[513],\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"participantsActive\":[32]}]]],[\"dyte-plugins-toggle.cjs\",[[1,\"dyte-plugins-toggle\",{\"variant\":[513],\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"pluginsActive\":[32]}]]],[\"dyte-polls-toggle.cjs\",[[1,\"dyte-polls-toggle\",{\"variant\":[513],\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"pollsActive\":[32],\"unreadPollsCount\":[32]}]]],[\"dyte-recording-toggle.cjs\",[[1,\"dyte-recording-toggle\",{\"variant\":[513],\"meeting\":[16],\"t\":[16],\"iconPack\":[16],\"size\":[513],\"recordingState\":[32],\"canRecord\":[32]}]]],[\"dyte-settings-toggle.cjs\",[[1,\"dyte-settings-toggle\",{\"variant\":[513],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16]}]]],[\"dyte-button.cjs\",[[1,\"dyte-button\",{\"size\":[513],\"variant\":[513],\"kind\":[513],\"reverse\":[516],\"disabled\":[516]}]]],[\"dyte-setup-screen.cjs\",[[1,\"dyte-setup-screen\",{\"meeting\":[16],\"size\":[513],\"config\":[16],\"states\":[16],\"iconPack\":[16],\"t\":[16],\"displayName\":[32],\"isJoining\":[32],\"canEditName\":[32]}]]],[\"dyte-image-viewer.cjs\",[[1,\"dyte-image-viewer\",{\"image\":[16],\"size\":[513],\"t\":[16],\"iconPack\":[16]}]]],[\"dyte-mixed-grid.cjs\",[[1,\"dyte-mixed-grid\",{\"participants\":[16],\"pinnedParticipants\":[16],\"screenShareParticipants\":[16],\"plugins\":[16],\"aspectRatio\":[1,\"aspect-ratio\"],\"gap\":[2],\"size\":[513],\"meeting\":[16],\"states\":[16],\"config\":[16],\"iconPack\":[16],\"t\":[16],\"activeTab\":[32]}]]],[\"dyte-permissions-message.cjs\",[[1,\"dyte-permissions-message\",{\"meeting\":[16],\"t\":[16],\"iconPack\":[16],\"device\":[32]}]]],[\"dyte-plugin-main.cjs\",[[1,\"dyte-plugin-main\",{\"meeting\":[16],\"plugin\":[16],\"iconPack\":[16],\"canClosePlugin\":[32]}]]],[\"dyte-plugins.cjs\",[[1,\"dyte-plugins\",{\"meeting\":[16],\"config\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"plugins\":[32],\"canStartPlugins\":[32],\"canClosePlugin\":[32],\"activatedPluginsId\":[32]}]]],[\"dyte-sidebar.cjs\",[[1,\"dyte-sidebar\",{\"enabledSections\":[16],\"defaultSection\":[1,\"default-section\"],\"meeting\":[16],\"states\":[16],\"config\":[16],\"iconPack\":[16],\"t\":[16],\"size\":[513],\"view\":[513],\"tab\":[32]}]]],[\"dyte-clock.cjs\",[[1,\"dyte-clock\",{\"meeting\":[16],\"iconPack\":[16],\"t\":[16],\"startedTime\":[32],\"timeDiff\":[32]}]]],[\"dyte-ended-screen.cjs\",[[1,\"dyte-ended-screen\",{\"config\":[16],\"size\":[513],\"states\":[16],\"t\":[16],\"icon\":[32],\"message\":[32]}]]],[\"dyte-leave-meeting.cjs\",[[1,\"dyte-leave-meeting\",{\"meeting\":[16],\"states\":[16],\"iconPack\":[16],\"t\":[16],\"canEndMeeting\":[32]}]]],[\"dyte-meeting-title.cjs\",[[1,\"dyte-meeting-title\",{\"meeting\":[16]}]]],[\"dyte-participant-count.cjs\",[[1,\"dyte-participant-count\",{\"meeting\":[16],\"iconPack\":[16],\"t\":[16],\"participantCount\":[32]}]]],[\"dyte-recording-indicator.cjs\",[[1,\"dyte-recording-indicator\",{\"meeting\":[16],\"size\":[513],\"t\":[16],\"iconPack\":[16],\"isRecording\":[32]}]]],[\"dyte-controlbar.cjs\",[[1,\"dyte-controlbar\",{\"variant\":[513],\"size\":[513]}]]],[\"dyte-grid.cjs\",[[1,\"dyte-grid\",{\"aspectRatio\":[513,\"aspect-ratio\"],\"meeting\":[16],\"gap\":[514],\"size\":[513],\"states\":[16],\"config\":[16],\"iconPack\":[16],\"t\":[16],\"participants\":[32],\"pinnedParticipants\":[32],\"screenShareParticipants\":[32],\"plugins\":[32],\"responsiveGap\":[32],\"dimensions\":[32]}]]],[\"dyte-header.cjs\",[[1,\"dyte-header\",{\"variant\":[513],\"size\":[513]}]]],[\"dyte-meeting.cjs\",[[1,\"dyte-meeting\",{\"loadConfigFromPreset\":[4,\"load-config-from-preset\"],\"applyDesignSystem\":[4,\"apply-design-system\"],\"mode\":[513],\"meeting\":[16],\"showSetupScreen\":[1028,\"show-setup-screen\"],\"language\":[513],\"config\":[1040],\"iconPackUrl\":[513,\"icon-pack-url\"],\"size\":[1537],\"states\":[32],\"iconPack\":[32],\"t\":[32]},[[0,\"dyteStateUpdate\",\"listenState\"]]]]],[\"dyte-name-tag.cjs\",[[1,\"dyte-name-tag\",{\"participant\":[16],\"meeting\":[16],\"size\":[513],\"maxLength\":[2,\"max-length\"],\"isScreenShare\":[4,\"is-screen-share\"],\"t\":[16],\"length\":[32]}]]],[\"dyte-simple-grid.cjs\",[[1,\"dyte-simple-grid\",{\"participants\":[16],\"aspectRatio\":[1,\"aspect-ratio\"],\"gap\":[2],\"size\":[513],\"meeting\":[16],\"states\":[16],\"config\":[16],\"iconPack\":[16],\"t\":[16],\"dimensions\":[32]}]]],[\"dyte-spotlight-grid.cjs\",[[1,\"dyte-spotlight-grid\",{\"participants\":[16],\"pinnedParticipants\":[16],\"aspectRatio\":[1,\"aspect-ratio\"],\"gap\":[2],\"size\":[513],\"meeting\":[16],\"states\":[16],\"config\":[16],\"iconPack\":[16],\"t\":[16]}]]],[\"dyte-stage.cjs\",[[1,\"dyte-stage\"]]],[\"dyte-text-field.cjs\",[[1,\"dyte-text-field\",{\"type\":[1],\"placeholder\":[1],\"disabled\":[4]}]]],[\"dyte-avatar.cjs\",[[1,\"dyte-avatar\",{\"participant\":[16],\"variant\":[513],\"size\":[513],\"iconPack\":[16],\"imageState\":[32]}]]],[\"dyte-participant.cjs\",[[1,\"dyte-participant\",{\"meeting\":[16],\"participant\":[16],\"iconPack\":[16],\"t\":[16],\"audioEnabled\":[32],\"videoEnabled\":[32],\"isPinned\":[32],\"canDisableParticipantAudio\":[32],\"canDisableParticipantVideo\":[32],\"canKickParticipant\":[32],\"canPinParticipant\":[32]}]]],[\"dyte-notification.cjs\",[[1,\"dyte-notification\",{\"notification\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"imageState\":[32]}]]],[\"dyte-participant-tile.cjs\",[[1,\"dyte-participant-tile\",{\"nameTagPosition\":[513,\"name-tag-position\"],\"isPreview\":[4,\"is-preview\"],\"participant\":[16],\"states\":[16],\"config\":[16],\"variant\":[513],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"videoState\":[32],\"isPinned\":[32]}]]],[\"dyte-audio-visualizer_2.cjs\",[[1,\"dyte-audio-visualizer\",{\"variant\":[513],\"participant\":[16],\"size\":[513],\"iconPack\":[16],\"isScreenShare\":[4,\"is-screen-share\"],\"isPreview\":[4,\"is-preview\"],\"audioEnabled\":[32],\"volume\":[32]}],[1,\"dyte-switch\",{\"checked\":[1028],\"readonly\":[4],\"disabled\":[516]}]]],[\"dyte-settings-audio_2.cjs\",[[1,\"dyte-settings-audio\",{\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"audioDevices\":[32],\"speakerDevices\":[32]}],[1,\"dyte-settings-video\",{\"meeting\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"videoDevices\":[32],\"currentDevice\":[32]}]]],[\"dyte-poll_2.cjs\",[[1,\"dyte-poll-form\",{\"iconPack\":[16],\"t\":[16],\"options\":[32],\"error\":[32]}],[1,\"dyte-poll\",{\"poll\":[16],\"self\":[1],\"iconPack\":[16],\"t\":[16]}]]],[\"dyte-dialog.cjs\",[[1,\"dyte-dialog\",{\"hideCloseButton\":[4,\"hide-close-button\"],\"meeting\":[16],\"config\":[16],\"states\":[16],\"size\":[513],\"iconPack\":[16],\"t\":[16],\"open\":[1540]}]]],[\"dyte-logo.cjs\",[[1,\"dyte-logo\",{\"logoUrl\":[1025,\"logo-url\"],\"config\":[16],\"meeting\":[16],\"t\":[16]}]]],[\"dyte-emoji-picker_4.cjs\",[[1,\"dyte-emoji-picker\",{\"t\":[16],\"emojiList\":[32],\"filterVal\":[32],\"filteredEmojis\":[32]}],[0,\"dyte-image-message\",{\"message\":[16],\"now\":[16],\"isContinued\":[516,\"is-continued\"],\"iconPack\":[16],\"t\":[16],\"status\":[32]}],[0,\"dyte-file-message\",{\"message\":[16],\"now\":[16],\"isContinued\":[516,\"is-continued\"],\"iconPack\":[16]}],[0,\"dyte-text-message\",{\"message\":[16],\"now\":[16],\"isContinued\":[516,\"is-continued\"]}]]],[\"dyte-menu_3.cjs\",[[1,\"dyte-menu\",{\"size\":[513],\"placement\":[1]}],[1,\"dyte-menu-item\",{\"size\":[513]}],[1,\"dyte-menu-list\"]]],[\"dyte-tooltip.cjs\",[[1,\"dyte-tooltip\",{\"label\":[1],\"variant\":[513],\"disabled\":[516],\"open\":[516],\"kind\":[513],\"size\":[513],\"placement\":[1],\"delay\":[2],\"isInFocus\":[32]}]]],[\"dyte-spinner.cjs\",[[1,\"dyte-spinner\",{\"iconPack\":[16]}]]],[\"dyte-controlbar-button.cjs\",[[1,\"dyte-controlbar-button\",{\"variant\":[513],\"showWarning\":[4,\"show-warning\"],\"size\":[513],\"label\":[1],\"icon\":[1],\"isLoading\":[4,\"is-loading\"],\"disabled\":[516],\"iconPack\":[16]}]]]]"), options);
});
